# %%
def reverse_complement(dna_sequence):
    """
    Wörtliche Umsetzung des Activity Diagrams
    """
    comp_sequence = []
    
    for nucleotide in dna_sequence:
        if nucleotide == 'A':
            comp_sequence.append('T')
        elif nucleotide == 'T':
            comp_sequence.append('A')
        elif nucleotide == 'G':
            comp_sequence.append('C')
        elif nucleotide == 'C':
            comp_sequence.append('G')
        
    comp_sequence.reverse()

    return "".join(comp_sequence)


def reverse_complement_error_save(dna_sequence):
    """
    Wörtliche Umsetzung des Activity Diagrams
    """
    comp_sequence = []
    
    for nucleotide in dna_sequence:
        if nucleotide == 'A':
            comp_sequence.append('T')
        elif nucleotide == 'T':
            comp_sequence.append('A')
        elif nucleotide == 'G':
            comp_sequence.append('C')
        elif nucleotide == 'C':
            comp_sequence.append('G')
        else:
            comp_sequence.append('_')
        
    comp_sequence.reverse()

    return "".join(comp_sequence)

#%%

def reverse_complement_long(dna_sequence):
    original_alphabet = ['A', 'T', 'G', 'C']
    replace_alphabet = ['T', 'A', 'C', 'G']
    
    reverse_comp_sequence = []
    
    for nucleotide  in dna_sequence:
        if nucleotide in original_alphabet:
            index = original_alphabet.index(nucleotide)
            reverse_comp_sequence.append(replace_alphabet[index])
        else:
            reverse_comp_sequence.append("_")  # In case of non-standard characters
    reverse_comp_sequence.reverse()

    return "".join(reverse_comp_sequence)


#%%
def reverse_complement_with_dict(dna_sequence):
    complement_dict = {'A': 'T', 'T': 'A', 'G': 'C', 'C': 'G'}
    
    reverse_comp_sequence = []
    
    for nucleotide in dna_sequence:
        if nucleotide in complement_dict:
            reverse_comp_sequence.append(complement_dict[nucleotide])
        else:
            reverse_comp_sequence.append("_")  # In case of non-standard characters
    
    reverse_comp_sequence.reverse()

    return "".join(reverse_comp_sequence)